library ac_dart.host_registration_persistence;

import 'package:atlassian_connect_host/host_model.dart';
import 'dart:async';
import 'package:logging/logging.dart';
export 'package:atlassian_connect_host/host_model.dart' show AcHostRegistration;
export 'dart:async' show Future;
import 'package:option/option.dart';
export 'package:option/option.dart';
export 'src/google_datastore/host_registration_datastore_persistence.dart';
export 'src/host_registration_test_persistence.dart';

final Logger _log = new Logger('AcHostRegistrationRepository');

typedef AcHostRegistrationRepository AcHostRegistrationRepositoryFactory();

/**
 * A Repository (DAO) for [AcHostRegistration] data
 */
abstract class AcHostRegistrationRepository {
  Future<AcHostRegistration> create(AcHostRegistration hostRegistration);

  Future<Option<AcHostRegistration>> findRegistrationByHostKey(String hostKey);
}

