library ac_dart.descriptor_model.bitbucket.locations;

import 'package:atlassian_connect_host/src/descriptor/descriptor_model.dart';

final _BitbucketLocations bitbucket = new _BitbucketLocations._();


const String _locationPrefix = 'org.bitbucket.';

class _BitbucketLocations {
  final _RepoLocations repository = new _RepoLocations._();
  final _AccountLocations account = new _AccountLocations._();

  _BitbucketLocations._();
}

class BitbucketLocation extends ModuleLocation {
  BitbucketLocation._(String key) : super(key);
}

class _RepoLocations {
  final BitbucketLocation actions = _create('actions');
  final BitbucketLocation admin = _create('admin');
  final BitbucketLocation navigation = _create('navigation');
  final BitbucketLocation informationPanel =
      _create('overview.informationPanel');

  _RepoLocations._();

  static BitbucketLocation _create(String suffix) =>
      new BitbucketLocation._(_locationPrefix + 'repository.' + suffix);
}

class _AccountLocations {
  final BitbucketLocation admin = _create('admin');

  _AccountLocations._();

  static BitbucketLocation _create(String suffix) =>
      new BitbucketLocation._(_locationPrefix + 'account.' + suffix);
}
