library ac_dart.hc.model.install;

import 'package:atlassian_connect_host/src/preconditions.dart';
import 'package:stuff/stuff.dart';

//class InstallationEvent {
//  final String oauthId;
//  final String oauthSecret;
//  final String capabilitiesUrl;
//  final int roomId;
//  final int groupId;
//
//  InstallationEvent.build({this.oauthId, this.oauthSecret, this.capabilitiesUrl,
//      this.roomId, this.groupId});
//
//  InstallationEvent.fromJson(Map json) : this.build(
//          oauthId: json['oauthId'],
//          oauthSecret: json['oauthSecret'],
//          capabilitiesUrl: json['capabilitiesUrl'],
//          roomId: json['roomId'],
//          groupId: json['groupId']);
//
//  Map toJson() => {
//    "oauthId": oauthId,
//    "oauthSecret": oauthSecret,
//    "capabilitiesUrl": capabilitiesUrl,
//    "roomId": roomId,
//    "groupId": groupId
//  };
//}

abstract class WebhookEvent {
  final String event;

  WebhookEvent(this.event) {
    checkNotNull(event, 'event');
  }
}

class RoomMessageEvent extends WebhookEvent {
  final RoomMessage item;

  RoomMessageEvent(this.item) : super('room_message') {
    checkNotNull(item, 'item');
  }
}

class RoomMessage {
  final Message message;
  final Room room;

  RoomMessage(this.message, this.room) {
    checkNotNull(message, 'message');
    checkNotNull(room, 'room');
  }

  RoomMessage.fromJson(Map json)
      : this(new Message.fromJson(json['message']),
            new Room.fromJson(json['room']));
}

class Message {
  final String message;

  Message({this.message});

  Message.fromJson(Map json) : this(message: json['message']);
}

class Room {
  Room();
  Room.fromJson(Map json);
}

class MessageFormat {
  final String literal;

  const MessageFormat._(this.literal);

  static const MessageFormat text = const MessageFormat._('text');

  static const MessageFormat html = const MessageFormat._('html');

  String toString() => literal;
}

class RoomNotification {
  final String color;
  final String message;
  final bool notify;
  final MessageFormat format;

  RoomNotification({this.color, this.message, this.notify, this.format});

  Map toJson() => (buildJson
    ..add('color', color)
    ..add('message', message)
    ..add('notify', notify)
    ..add('format', format)).json;
}

final f = {
  "event": "room_message",
  "item": {
    "message": {
      "date": "2014-11-10T05:24:11.497247+00:00",
      "from": {
        "id": 1,
        "links": {"self": "https://dev-aholmgren1.hipchat.com/v2/user/1"},
        "mention_name": "AndersHolmgren",
        "name": "Anders Holmgren"
      },
      "id": "7d5198e6-a6e0-46fe-8889-4ef5d26e74fd",
      "mentions": [],
      "message": "spamme: foo",
      "type": "message"
    },
    "room": {
      "id": 1,
      "links": {
        "participants":
            "https://dev-aholmgren1.hipchat.com/v2/room/1/participant",
        "self": "https://dev-aholmgren1.hipchat.com/v2/room/1",
        "webhooks": "https://dev-aholmgren1.hipchat.com/v2/room/1/webhook"
      },
      "name": "Atlassian"
    }
  },
  "oauth_client_id": "3bdda657-d93f-48c5-874b-fccbf912b420",
  "webhook_id": 20
};
