library ac_dart.host_registration_persistence.datastore.model;

import 'package:gcloud/db.dart';
import 'dart:convert';
import 'package:atlassian_connect_host/atlassian_connect_host.dart';

@Kind(idType: IdType.String)
class AcHostRegistrationRecord extends Model {
  @StringProperty(indexed: false)
  String registrationJsonStr;

  AcHostRegistration get registration =>
      new AcHostRegistration.fromJson(JSON.decode(registrationJsonStr));

  void set registration(AcHostRegistration registration) {
    id = registration.hostDetails.key;
    print('id is $id of type ${id.runtimeType}');
    this.registrationJsonStr = JSON.encode(registration);
  }


  AcHostRegistrationRecord() {}

  AcHostRegistrationRecord.fromRegistration(AcHostRegistration hostRegistration,
      Key parentKey) {
    this.registrationJsonStr = JSON.encode(hostRegistration);
    this.id = hostRegistration.hostDetails.key;
    this.parentKey = parentKey;
  }
}
