library ac_dart.host_event_model.hipchat;

import 'package:atlassian_connect_host/host_model.dart';
import 'package:atlassian_connect_host/host_event_model.dart';
import 'hc_host_model.dart';

class HcInstallationEvent extends AcHostEvent implements InstallationEvent {
//  @NotNull()
  final AcHostRegistration hostRegistration;

  HcInstallationEvent(this.hostRegistration) : super(AcHostEventType.installed);

  HcInstallationEvent.fromJson(Map json)
      : this((new AcHostRegistration.build(
            sharedSecret: json['oauthSecret'],
            hostDetails: (new HcAcHostDetails.build(
                oauthId: json['oauthId'],
                capabilitiesUrl: Uri.parse(json['capabilitiesUrl']),
                roomId: json['roomId'],
                groupId: json['groupId'])))));

  Map toJson() =>
      super.toJson()..addAll({'hostRegistration': hostRegistration});

  String toString() => 'InstallationEvent[$hostRegistration]';
}
