library ac_dart.host_model.hipchat;

import 'package:atlassian_connect_host/host_model.dart';
import 'package:uri/uri.dart';

class HcAcHostDetails extends AcHostDetails {
  String get oauthId => key;
  final Uri capabilitiesUrl;
  final int roomId;
  final int groupId;

  HcAcHostDetails(
      String oauthId, Uri capabilitiesUrl, this.roomId, this.groupId)
      : this.capabilitiesUrl = capabilitiesUrl,
        super(oauthId, ProductType.hipchat, null, _baseUri(capabilitiesUrl));

  HcAcHostDetails.build(
      {String oauthId, Uri capabilitiesUrl, int roomId, int groupId})
      : this(oauthId, capabilitiesUrl, roomId, groupId);

  HcAcHostDetails.fromJson(Map json)
      : this(json['key'], Uri.parse(json['capabilitiesUrl']), json['roomId'],
            json['groupId']);

  Map toJson() => super.toJson()
    ..addAll({
      'capabilitiesUrl': capabilitiesUrl.toString(),
      'roomId': roomId,
      'groupId': groupId
    });
}

Uri _baseUri(Uri capabilitiesUri) => (new UriBuilder.fromUri(capabilitiesUri)
  ..path = null
  ..fragment = null
  ..queryParameters = null).build();
